<?php

class paybylink
{

    var $code;
    var $title;
    var $description;
    var $enabled;

    function paybylink()
    {
        global $order;

        $this->code = 'paybylink';
        $this->codeVersion = '1.0';
        $this->title = 'paybylink.pl';
        $this->description = 'Płatności paybylink.pl';
        $this->sort_order = MODULE_PAYMENT_PAYBYLINK_SORT_ORDER;
        $this->enabled = ((MODULE_PAYMENT_PAYBYLINK_STATUS === 'Tak') ? true : false);
        if(is_object($order)) {
            $this->update_status();
        }
    }

    function update_status()
    {
        global $order;

        if ($order->info['currency'] !== 'PLN') {
            $this->enabled = false;
        }
    }

    function install()
    {
        global $db;

        tep_db_query("insert into " . TABLE_CONFIGURATION .
            " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
					('ID Sklepu', 'PBL_SHOPID','0', 'ID Sklepu Paybylink', '6', '2', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION .
            " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
					('Hash', 'PBL_HASH','', 'Hash Sklepu paybylink', '6', '2', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION .
            " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values 
					('Włącz moduł Paybylink', 'MODULE_PAYMENT_PAYBYLINK_STATUS', 'Nie', 'Czy chcesz obsługiwać płatności paybylink.pl?', '6', '1', 'tep_cfg_select_option(array(\'Tak\', \'Nie\'), ', now());");
        tep_db_query("insert into " . TABLE_CONFIGURATION .
            " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
					('Sortowanie wyświetlania', 'MODULE_PAYMENT_PAYBYLINK_SORT_ORDER', '0', 'Ni&#380;sze wartości wyświetlane pierwsze', '6', '0', now())");
    }

    function remove()
    {
        global $db;
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '",
                $this->keys()) . "')");
    }

    function keys()
    {
        return [
            'PBL_SHOPID',
            'PBL_HASH',
            'MODULE_PAYMENT_PAYBYLINK_STATUS',
            'MODULE_PAYMENT_PAYBYLINK_SORT_ORDER',
        ];
    }

    function check()
    {
        global $db;

        if (!isset($this->_check)) {
            $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYBYLINK_STATUS'");
            $this->_check = tep_db_num_rows($check_query);
        }

        return $this->_check;
    }

    function javascript_validation()
    {
        return false;
    }

    function selection()
    {
        return [
            'id' => $this->code,
            'module' => $this->title
        ];
    }

    function pre_confirmation_check()
    {
        global $cartID, $cart;

        if (empty($cart->cartID)) {
            $cartID = $cart->cartID = $cart->generate_cart_id();
        }

        if (!tep_session_is_registered('cartID')) {
            tep_session_register('cartID');
        }
        return false;
    }

    function confirmation()
    {
        return false;
    }

    function process_button()
    {
        return false;
    }

    function before_process()
    {
        return false;
    }

    function after_process()
    {
        global $db, $order, $insert_id, $cart;

        $shopId             = intval(PBL_SHOPID);
        $description        = strval('Zamówienie ' . $insert_id);
        $control            = strval($insert_id);
        $email              = strval($order->customer['email_address']);
        $price              = floatval(round($order->info['total'], 2));
        $notifyURL          = strval(tep_href_link('pbl_itn.php', '', 'SSL', false, false, true));
        $returnUrlSuccess   = strval(tep_href_link(FILENAME_CHECKOUT_SUCCESS, 'referer=paybylink', 'SSL'));
        $hash               = PBL_HASH;
    
        $data   = $hash . "|" . $shopId . "|" . sprintf("%.2f", $price);
    
        if ($control != null && $control != "") {
            $data .= "|" . $control;
        }
    
        if ($description != null && $description != "") {
            $data .= "|" . $description;
        }
        
        if ($email != null && $email != "") {
            $data .= "|" . $email;
        }
    
        if ($notifyURL != null && $notifyURL != "") {
            $data .= "|" . $notifyURL;
        }
    
        if ($returnUrlSuccess != null && $returnUrlSuccess != "") {
            $data .= "|" . $returnUrlSuccess;
        }
    
        $signature = hash('sha256', $data);
    
        $paybylinkData  = [
            'shopId'            => $shopId,
            'price'             => $price,
            'control'           => $control,
            'description'       => $description,
            'email'             => $email,
            'notifyURL'         => $notifyURL,
            'returnUrlSuccess'  => $returnUrlSuccess,
            'signature'         => $signature
        ];
    
        $data_string = json_encode($paybylinkData);
    
        $ch = curl_init('https://secure.pbl.pl/api/v1/transfer/generate');                                                                      
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');                                                                    
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
            'Content-Type: application/json',                                                                                
            'Content-Length: ' . strlen($data_string))                                                                      
        );
    
        $result = curl_exec($ch);
        $result = json_decode($result);
    
        if(isset($result->transactionId) AND !empty($result->transactionId)) {
            $payURL = 'https://secure.pbl.pl/transfer/' . $result->transactionId;
        }

        $cart->reset(true);
        tep_session_unregister('sendto');
        tep_session_unregister('billto');
        tep_session_unregister('shipping');
        tep_session_unregister('payment');
        tep_session_unregister('comments');

        header('Location: ' . $payURL);
        exit('<a href="' . $payURL . '">Kliknij tutaj jeśli nie zostaniesz przekierowany do płatności</a>');
    }

    function get_error()
    {
        return false;
    }

}