<?php

require('includes/application_top.php');

header('HTTP/1.1 200 OK');
header('Content-Type: text/plain');

$response = file_get_contents('php://input');

if(!empty($response)) {
    $response = json_decode($response, true);

    $pbl_data = array(
        'transactionId' => $response['transactionId'],
        'control' => $response['control'],
        'email' => $response['email'],
        'amountPaid' => $response['amountPaid'],
        'notificationAttempt' => $response['notificationAttempt'],
        'paymentType' => $response['paymentType'],
        'apiVersion' => $response['apiVersion'],
        'signature' => $response['signature']
    );

    if(!checkSignature(PBL_HASH, $pbl_data)) {
        exit('Wrong checksum');
    }

    tep_db_perform(TABLE_ORDERS, ['orders_status' => 2], 'update', 'orders_id=' . $response['control']);
    $sqlData = [
        'orders_id'         => $response['control'],
        'orders_status_id'  => 2,
        'date_added'        => 'now()',
        'customer_notified' => '0',
        'comments'          => trim('Transaction ID: ' . (string)$response['transactionId'])
    ];

    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sqlData);

    ob_clean();
    exit('OK');
} else {
    exit('Empty response');
}

function checkSignature($secret, $data){
    $sign = sprintf("%s|%s|%s|%s|%.2f|%d|%s|%d", $secret, $data['transactionId'], $data['control'], $data['email'], $data['amountPaid'], $data['notificationAttempt'], $data['paymentType'], $data['apiVersion']);
    $hash = hash('sha256', $sign);
    return $hash == $data['signature'];
}